rpms/gdb/devel gdb-6.6-buildid-locate-rpm.patch, 1.1, 1.2 gdb-6.6-buildid-locate.patch, 1.18, 1.19 gdb.spec, 1.328, 1.329

Jan Kratochvil jkratoch at fedoraproject.org
Sat Mar 7 16:53:10 UTC 2009


Author: jkratoch

Update of /cvs/pkgs/rpms/gdb/devel
In directory cvs1.fedora.phx.redhat.com:/tmp/cvs-serv22393

Modified Files:
	gdb-6.6-buildid-locate-rpm.patch gdb-6.6-buildid-locate.patch 
	gdb.spec 
Log Message:
* Sat Mar  7 2009 Jan Kratochvil <jan.kratochvil at redhat.com> - 6.8.50.20090302-5
- Improve `gdb-6.6-buildid-locate-rpm.patch' by dlopen() (+pkg-config compat.).


gdb-6.6-buildid-locate-rpm.patch:

Index: gdb-6.6-buildid-locate-rpm.patch
===================================================================
RCS file: /cvs/pkgs/rpms/gdb/devel/gdb-6.6-buildid-locate-rpm.patch,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- gdb-6.6-buildid-locate-rpm.patch	7 Mar 2009 01:42:03 -0000	1.1
+++ gdb-6.6-buildid-locate-rpm.patch	7 Mar 2009 16:52:38 -0000	1.2
@@ -1,25 +1,7 @@
---- ./gdb/Makefile.in	2009-03-07 01:45:51.000000000 +0100
-+++ ./gdb/Makefile.in	2009-03-07 01:52:00.000000000 +0100
-@@ -396,7 +396,7 @@ CONFIG_UNINSTALL = @CONFIG_UNINSTALL@
- # your system doesn't have fcntl.h in /usr/include (which is where it
- # should be according to Posix).
- DEFS = @DEFS@
--GDB_CFLAGS = -I. -I$(srcdir) -I$(srcdir)/config -DLOCALEDIR="\"$(localedir)\"" $(DEFS)
-+GDB_CFLAGS = -I. -I$(srcdir) -I$(srcdir)/config -I$(includedir)/rpm -DLOCALEDIR="\"$(localedir)\"" $(DEFS)
- 
- # MH_CFLAGS, if defined, has host-dependent CFLAGS from the config directory.
- GLOBAL_CFLAGS = $(MH_CFLAGS)
-@@ -449,7 +449,7 @@ INSTALLED_LIBS=-lbfd -lreadline -lopcode
- CLIBS = $(SIM) $(READLINE) $(OPCODES) $(BFD) $(INTL) $(LIBIBERTY) $(LIBDECNUMBER) \
- 	$(XM_CLIBS) $(NAT_CLIBS) $(GDBTKLIBS) @LIBS@ \
- 	$(LIBICONV) $(LIBEXPAT) \
--	$(LIBIBERTY) $(WIN32LIBS) $(LIBGNU)
-+	$(LIBIBERTY) $(WIN32LIBS) $(LIBGNU) -lrpm
- CDEPS = $(XM_CDEPS) $(NAT_CDEPS) $(SIM) $(BFD) $(READLINE_DEPS) \
- 	$(OPCODES) $(INTL_DEPS) $(LIBIBERTY) $(CONFIG_DEPS) $(LIBGNU)
- 
---- ./gdb/event-top.c	2009-03-07 02:29:51.000000000 +0100
-+++ ./gdb/event-top.c	2009-03-07 01:52:00.000000000 +0100
+Index: gdb-6.8.50.20090302/gdb/event-top.c
+===================================================================
+--- gdb-6.8.50.20090302.orig/gdb/event-top.c	2009-03-07 17:13:33.000000000 +0100
++++ gdb-6.8.50.20090302/gdb/event-top.c	2009-03-07 17:25:06.000000000 +0100
 @@ -33,6 +33,7 @@
  #include "cli/cli-script.h"     /* for reset_command_nest_depth */
  #include "main.h"
@@ -46,8 +28,10 @@
    /* Each interpreter has its own rules on displaying the command
       prompt.  */
    if (!current_interp_display_prompt_p ())
---- ./gdb/symfile.c	2009-03-07 02:30:20.000000000 +0100
-+++ ./gdb/symfile.c	2009-03-07 01:52:00.000000000 +0100
+Index: gdb-6.8.50.20090302/gdb/symfile.c
+===================================================================
+--- gdb-6.8.50.20090302.orig/gdb/symfile.c	2009-03-07 17:22:21.000000000 +0100
++++ gdb-6.8.50.20090302/gdb/symfile.c	2009-03-07 17:26:47.000000000 +0100
 @@ -55,6 +55,7 @@
  #include "solib.h"
  #include "remote.h"
@@ -64,14 +48,19 @@
  
  
  int (*deprecated_ui_load_progress_hook) (const char *section, unsigned long num);
-@@ -1684,6 +1686,269 @@ build_id_to_filename (struct build_id *b
+@@ -1684,8 +1686,352 @@ build_id_to_filename (struct build_id *b
    return retval;
  }
  
++#ifdef HAVE_LIBRPM
++
 +#include <rpm/rpmlib.h>
 +#include <rpm/rpmts.h>
 +#include <rpm/rpmdb.h>
 +#include <rpm/header.h>
++#ifdef DLOPEN_LIBRPM
++#include <dlfcn.h>
++#endif
 +
 +/* This MISSING_RPM_HASH tracker is used to collect all the missing rpm files
 +   and avoid their duplicities during a single inferior run.  */
@@ -101,22 +90,93 @@
 +  rpmdbMatchIterator mi;
 +  int count = 0;
 +
++#ifdef DLOPEN_LIBRPM
++  /* Duplicate here the declarations to verify they match.  The same sanity
++     check is present also in `configure.ac'.  */
++  extern char * headerFormat(Header h, const char * fmt, errmsg_t * errmsg);
++  static char *(*headerFormat_p) (Header h, const char * fmt, errmsg_t *errmsg);
++  extern int rpmReadConfigFiles(const char * file, const char * target);
++  static int (*rpmReadConfigFiles_p) (const char * file, const char * target);
++  extern rpmdbMatchIterator rpmdbFreeIterator(rpmdbMatchIterator mi);
++  static rpmdbMatchIterator (*rpmdbFreeIterator_p) (rpmdbMatchIterator mi);
++  extern Header rpmdbNextIterator(rpmdbMatchIterator mi);
++  static Header (*rpmdbNextIterator_p) (rpmdbMatchIterator mi);
++  extern rpmts rpmtsCreate(void);
++  static rpmts (*rpmtsCreate_p) (void);
++  extern rpmts rpmtsFree(rpmts ts);
++  static rpmts (*rpmtsFree_p) (rpmts ts);
++  extern rpmdbMatchIterator rpmtsInitIterator(const rpmts ts, rpmTag rpmtag,
++                                              const void * keyp, size_t keylen);
++  static rpmdbMatchIterator (*rpmtsInitIterator_p) (const rpmts ts,
++						    rpmTag rpmtag,
++						    const void *keyp,
++						    size_t keylen);
++#else	/* !DLOPEN_LIBRPM */
++# define headerFormat_p headerFormat
++# define rpmReadConfigFiles_p rpmReadConfigFiles
++# define rpmdbFreeIterator_p rpmdbFreeIterator
++# define rpmdbNextIterator_p rpmdbNextIterator
++# define rpmtsCreate_p rpmtsCreate
++# define rpmtsFree_p rpmtsFree
++# define rpmtsInitIterator_p rpmtsInitIterator
++#endif	/* !DLOPEN_LIBRPM */
++
 +  if (filename == NULL)
 +    return 0;
 +
 +  if (!rpm_init_done)
 +    {
-+      if (rpmReadConfigFiles(NULL, NULL) != 0)
++      static int init_tried;
++
++      /* Already failed the initialization before?  */
++      if (init_tried)
++      	return 0;
++      init_tried = 1;
++
++#ifdef DLOPEN_LIBRPM
++      {
++	void *h;
++
++	h = dlopen (DLOPEN_LIBRPM, RTLD_LAZY);
++	if (!h)
++	  {
++	    warning (_("Unable to open \"%s\" (%s), "
++		      "missing debuginfos notifications will not be displayed"),
++		     DLOPEN_LIBRPM, dlerror ());
++	    return 0;
++	  }
++
++	if (!((headerFormat_p = dlsym (h, "headerFormat"))
++	      && (rpmReadConfigFiles_p = dlsym (h, "rpmReadConfigFiles"))
++	      && (rpmdbFreeIterator_p = dlsym (h, "rpmdbFreeIterator"))
++	      && (rpmdbNextIterator_p = dlsym (h, "rpmdbNextIterator"))
++	      && (rpmtsCreate_p = dlsym (h, "rpmtsCreate"))
++	      && (rpmtsFree_p = dlsym (h, "rpmtsFree"))
++	      && (rpmtsInitIterator_p = dlsym (h, "rpmtsInitIterator"))))
++	  {
++	    warning (_("Opened library \"%s\" is incompatible (%s), "
++		      "missing debuginfos notifications will not be displayed"),
++		     DLOPEN_LIBRPM, dlerror ());
++	    if (dlclose (h))
++	      warning (_("Error closing library \"%s\": %s\n"), DLOPEN_LIBRPM,
++		       dlerror ());
++	    return 0;
++	  }
++      }
++#endif	/* DLOPEN_LIBRPM */
++
++      if (rpmReadConfigFiles_p (NULL, NULL) != 0)
 +	{
 +	  warning (_("Error reading the rpm configuration files"));
 +	  return 0;
 +	}
++
 +      rpm_init_done = 1;
 +    }
 +
-+  ts = rpmtsCreate ();
++  ts = rpmtsCreate_p ();
 +
-+  mi = rpmtsInitIterator (ts, RPMTAG_BASENAMES, filename, 0);
++  mi = rpmtsInitIterator_p (ts, RPMTAG_BASENAMES, filename, 0);
 +  if (mi != NULL)
 +    {
 +      for (;;)
@@ -128,13 +188,14 @@
 +	  size_t debuginfolen = sizeof ("-debuginfo") - 1;
 +	  rpmdbMatchIterator mi_debuginfo;
 +
-+	  h = rpmdbNextIterator (mi);
++	  h = rpmdbNextIterator_p (mi);
 +	  if (h == NULL)
 +	    break;
 +
 +	  /* Verify the debuginfo file is not already installed.  */
-+ 
-+	  debuginfo = headerFormat (h, "%{sourcerpm}-debuginfo.%{arch}", &err);
++
++	  debuginfo = headerFormat_p (h, "%{sourcerpm}-debuginfo.%{arch}",
++				      &err);
 +	  if (!debuginfo)
 +	    {
 +	      warning (_("Error querying the rpm file `%s': %s"), filename,
@@ -175,19 +236,19 @@
 +
 +	  /* RPMDBI_PACKAGES requires keylen == sizeof (int).  */
 +	  /* RPMDBI_LABEL is an interface for NVR-based dbiFindByLabel().  */
-+	  mi_debuginfo = rpmtsInitIterator (ts, RPMDBI_LABEL, debuginfo, 0);
++	  mi_debuginfo = rpmtsInitIterator_p (ts, RPMDBI_LABEL, debuginfo, 0);
 +	  xfree (debuginfo);
 +	  if (mi_debuginfo)
 +	    {
-+	      rpmdbFreeIterator (mi_debuginfo);
++	      rpmdbFreeIterator_p (mi_debuginfo);
 +	      count = 0;
 +	      break;
 +	    }
 +
 +	  /* The allocated memory gets utilized below for MISSING_RPM_HASH.  */
-+	  debuginfo = headerFormat (h,
-+				    "%{name}-%{version}-%{release}.%{arch}",
-+				    &err);
++	  debuginfo = headerFormat_p (h,
++				      "%{name}-%{version}-%{release}.%{arch}",
++				      &err);
 +	  if (!debuginfo)
 +	    {
 +	      warning (_("Error querying the rpm file `%s': %s"), filename,
@@ -237,10 +298,10 @@
 +	  count++;
 +	}
 +
-+      rpmdbFreeIterator (mi);
++      rpmdbFreeIterator_p (mi);
 +    }
 +
-+  rpmtsFree (ts);
++  rpmtsFree_p (ts);
 +
 +  return count;
 +}
@@ -325,35 +386,47 @@
 +  };
 +static enum missing_exec missing_exec = MISSING_EXEC_NOT_TRIED;
 +
++#endif	/* HAVE_LIBRPM */
++
 +void
 +debug_flush_missing (void)
 +{
++#ifdef HAVE_LIBRPM
 +  missing_rpm_list_print ();
++#endif
 +}
 +
  /* This MISSING_FILEPAIR_HASH tracker is used only for the duplicite messages
-      yum --enablerepo='*-debuginfo' install ...
+-     Try to install the hash file ...
++     yum --enablerepo='*-debuginfo' install ...
     avoidance.  */
-@@ -1739,11 +2004,13 @@ missing_filepair_change (void)
+ 
+ struct missing_filepair
+@@ -1739,11 +2085,17 @@ missing_filepair_change (void)
        /* All their memory came just from missing_filepair_OBSTACK.  */
        missing_filepair_hash = NULL;
      }
++#ifdef HAVE_LIBRPM
 +  missing_exec = MISSING_EXEC_NOT_TRIED;
++#endif
  }
  
  static void
  debug_print_executable_changed (void)
  {
++#ifdef HAVE_LIBRPM
 +  missing_rpm_change ();
++#endif
    missing_filepair_change ();
  }
  
-@@ -1802,14 +2069,31 @@ debug_print_missing (const char *binary,
+@@ -1802,14 +2154,33 @@ debug_print_missing (const char *binary,
      }
    *slot = missing_filepair;
  
 -  /* We do not collect and flush these messages as each such message
 -     already requires its own separate lines.  */
++#ifdef HAVE_LIBRPM
 +  if (missing_exec == MISSING_EXEC_NOT_TRIED)
 +    {
 +      char *exec_filename;
@@ -361,8 +434,8 @@
 -  fprintf_unfiltered (gdb_stdlog,
 -		      _("Missing separate debuginfo for %s\n"), binary);
 -  if (debug != NULL)
--    fprintf_unfiltered (gdb_stdlog, _("Try: %s %s\n"),
--			"yum --enablerepo='*-debuginfo' install", debug);
+-    fprintf_unfiltered (gdb_stdlog, _("Try to install the hash file %s\n"),
+-			debug);
 +      exec_filename = get_exec_file (0);
 +      if (exec_filename != NULL)
 +	{
@@ -374,6 +447,7 @@
 +    }
 +  if (missing_exec != MISSING_EXEC_ENLISTED)
 +    if (missing_rpm_enlist (binary) == 0 && missing_rpm_enlist (debug) == 0)
++#endif	/* HAVE_LIBRPM */
 +      {
 +	/* We do not collect and flush these messages as each such message
 +	   already requires its own separate lines.  */
@@ -387,8 +461,10 @@
  }
  
  static char *
---- ./gdb/symfile.h	2009-03-07 02:16:18.000000000 +0100
-+++ ./gdb/symfile.h	2009-03-07 01:52:00.000000000 +0100
+Index: gdb-6.8.50.20090302/gdb/symfile.h
+===================================================================
+--- gdb-6.8.50.20090302.orig/gdb/symfile.h	2009-03-07 17:13:33.000000000 +0100
++++ gdb-6.8.50.20090302/gdb/symfile.h	2009-03-07 17:25:06.000000000 +0100
 @@ -378,6 +378,7 @@ extern struct build_id *build_id_addr_ge
  extern char *build_id_to_filename (struct build_id *build_id,
  				   char **link_return, int add_debug_suffix);
@@ -397,8 +473,10 @@
  
  /* From dwarf2read.c */
  
---- ./gdb/testsuite/lib/gdb.exp	2009-03-07 02:10:11.000000000 +0100
-+++ ./gdb/testsuite/lib/gdb.exp	2009-03-07 01:52:00.000000000 +0100
+Index: gdb-6.8.50.20090302/gdb/testsuite/lib/gdb.exp
+===================================================================
+--- gdb-6.8.50.20090302.orig/gdb/testsuite/lib/gdb.exp	2009-03-07 17:13:33.000000000 +0100
++++ gdb-6.8.50.20090302/gdb/testsuite/lib/gdb.exp	2009-03-07 17:25:06.000000000 +0100
 @@ -1230,7 +1230,7 @@ proc default_gdb_start { } {
  	    warning "Couldn't set the width to 0."
  	}
@@ -408,8 +486,10 @@
      send_gdb "set build-id-verbose 0\n"
      gdb_expect 10 {
  	-re "$gdb_prompt $" {
---- ./gdb/tui/tui-interp.c	2009-03-07 02:28:47.000000000 +0100
-+++ ./gdb/tui/tui-interp.c	2009-03-07 01:52:00.000000000 +0100
+Index: gdb-6.8.50.20090302/gdb/tui/tui-interp.c
+===================================================================
+--- gdb-6.8.50.20090302.orig/gdb/tui/tui-interp.c	2009-03-07 17:13:33.000000000 +0100
++++ gdb-6.8.50.20090302/gdb/tui/tui-interp.c	2009-03-07 17:25:06.000000000 +0100
 @@ -30,6 +30,7 @@
  #include "tui/tui.h"
  #include "tui/tui-io.h"
@@ -427,3 +507,1154 @@
        /* Tell readline what the prompt to display is and what function
           it will need to call after a whole line is read. This also
           displays the first prompt.  */
+Index: gdb-6.8.50.20090302/gdb/aclocal.m4
+===================================================================
+--- gdb-6.8.50.20090302.orig/gdb/aclocal.m4	2009-03-07 17:13:33.000000000 +0100
++++ gdb-6.8.50.20090302/gdb/aclocal.m4	2009-03-07 17:25:06.000000000 +0100
+@@ -11,6 +11,162 @@
+ # even the implied warranty of MERCHANTABILITY or FITNESS FOR A
+ # PARTICULAR PURPOSE.
+ 
++# pkg.m4 - Macros to locate and utilise pkg-config.            -*- Autoconf -*-
++# 
++# Copyright © 2004 Scott James Remnant <scott at netsplit.com>.
++#
++# This program is free software; you can redistribute it and/or modify
++# it under the terms of the GNU General Public License as published by
++# the Free Software Foundation; either version 2 of the License, or
++# (at your option) any later version.
++#
++# This program is distributed in the hope that it will be useful, but
++# WITHOUT ANY WARRANTY; without even the implied warranty of
++# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
++# General Public License for more details.
++#
++# You should have received a copy of the GNU General Public License
++# along with this program; if not, write to the Free Software
++# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
++#
++# As a special exception to the GNU General Public License, if you
++# distribute this file as part of a program that contains a
++# configuration script generated by Autoconf, you may include it under
++# the same distribution terms that you use for the rest of that program.
++
++# PKG_PROG_PKG_CONFIG([MIN-VERSION])
++# ----------------------------------
++AC_DEFUN([PKG_PROG_PKG_CONFIG],
++[m4_pattern_forbid([^_?PKG_[A-Z_]+$])
++m4_pattern_allow([^PKG_CONFIG(_PATH)?$])
++AC_ARG_VAR([PKG_CONFIG], [path to pkg-config utility])dnl
++if test "x$ac_cv_env_PKG_CONFIG_set" != "xset"; then
++	AC_PATH_TOOL([PKG_CONFIG], [pkg-config])
++fi
++if test -n "$PKG_CONFIG"; then
++	_pkg_min_version=m4_default([$1], [0.9.0])
++	AC_MSG_CHECKING([pkg-config is at least version $_pkg_min_version])
++	if $PKG_CONFIG --atleast-pkgconfig-version $_pkg_min_version; then
++		AC_MSG_RESULT([yes])
++	else
++		AC_MSG_RESULT([no])
++		PKG_CONFIG=""
++	fi
++		
++fi[]dnl
++])# PKG_PROG_PKG_CONFIG
++
++# PKG_CHECK_EXISTS(MODULES, [ACTION-IF-FOUND], [ACTION-IF-NOT-FOUND])
++#
++# Check to see whether a particular set of modules exists.  Similar
++# to PKG_CHECK_MODULES(), but does not set variables or print errors.
++#
++#
++# Similar to PKG_CHECK_MODULES, make sure that the first instance of
++# this or PKG_CHECK_MODULES is called, or make sure to call
++# PKG_CHECK_EXISTS manually
++# --------------------------------------------------------------
++AC_DEFUN([PKG_CHECK_EXISTS],
++[AC_REQUIRE([PKG_PROG_PKG_CONFIG])dnl
++if test -n "$PKG_CONFIG" && \
++    AC_RUN_LOG([$PKG_CONFIG --exists --print-errors "$1"]); then
++  m4_ifval([$2], [$2], [:])
++m4_ifvaln([$3], [else
++  $3])dnl
++fi])
++
++
++# _PKG_CONFIG([VARIABLE], [COMMAND], [MODULES])
++# ---------------------------------------------
++m4_define([_PKG_CONFIG],
++[if test -n "$$1"; then
++    pkg_cv_[]$1="$$1"
++ elif test -n "$PKG_CONFIG"; then
++    PKG_CHECK_EXISTS([$3],
++                     [pkg_cv_[]$1=`$PKG_CONFIG --[]$2 "$3" 2>/dev/null`],
++		     [pkg_failed=yes])
++ else
++    pkg_failed=untried
++fi[]dnl
++])# _PKG_CONFIG
++
++# _PKG_SHORT_ERRORS_SUPPORTED
++# -----------------------------
++AC_DEFUN([_PKG_SHORT_ERRORS_SUPPORTED],
++[AC_REQUIRE([PKG_PROG_PKG_CONFIG])
++if $PKG_CONFIG --atleast-pkgconfig-version 0.20; then
++        _pkg_short_errors_supported=yes
++else
++        _pkg_short_errors_supported=no
++fi[]dnl
++])# _PKG_SHORT_ERRORS_SUPPORTED
++
++
++# PKG_CHECK_MODULES(VARIABLE-PREFIX, MODULES, [ACTION-IF-FOUND],
++# [ACTION-IF-NOT-FOUND])
++#
++#
++# Note that if there is a possibility the first call to
++# PKG_CHECK_MODULES might not happen, you should be sure to include an
++# explicit call to PKG_PROG_PKG_CONFIG in your configure.ac
++#
++#
++# --------------------------------------------------------------
++AC_DEFUN([PKG_CHECK_MODULES],
++[AC_REQUIRE([PKG_PROG_PKG_CONFIG])dnl
++AC_ARG_VAR([$1][_CFLAGS], [C compiler flags for $1, overriding pkg-config])dnl
++AC_ARG_VAR([$1][_LIBS], [linker flags for $1, overriding pkg-config])dnl
++
++pkg_failed=no
++AC_MSG_CHECKING([for $1])
++
++_PKG_CONFIG([$1][_CFLAGS], [cflags], [$2])
++_PKG_CONFIG([$1][_LIBS], [libs], [$2])
++
++m4_define([_PKG_TEXT], [Alternatively, you may set the environment variables $1[]_CFLAGS
++and $1[]_LIBS to avoid the need to call pkg-config.
++See the pkg-config man page for more details.])
++
++if test $pkg_failed = yes; then
++        _PKG_SHORT_ERRORS_SUPPORTED
++        if test $_pkg_short_errors_supported = yes; then
++	        $1[]_PKG_ERRORS=`$PKG_CONFIG --short-errors --print-errors "$2" 2>&1`
++        else 
++	        $1[]_PKG_ERRORS=`$PKG_CONFIG --print-errors "$2" 2>&1`
++        fi
++	# Put the nasty error message in config.log where it belongs
++	echo "$$1[]_PKG_ERRORS" >&AS_MESSAGE_LOG_FD
++
++	ifelse([$4], , [AC_MSG_ERROR(dnl
++[Package requirements ($2) were not met:
++
++$$1_PKG_ERRORS
++
++Consider adjusting the PKG_CONFIG_PATH environment variable if you
++installed software in a non-standard prefix.
++
++_PKG_TEXT
++])],
++		[AC_MSG_RESULT([no])
++                $4])
++elif test $pkg_failed = untried; then
++	ifelse([$4], , [AC_MSG_FAILURE(dnl
++[The pkg-config script could not be found or is too old.  Make sure it
++is in your PATH or set the PKG_CONFIG environment variable to the full
++path to pkg-config.
++
++_PKG_TEXT
++
++To get pkg-config, see <http://pkg-config.freedesktop.org/>.])],
++		[$4])
++else
++	$1[]_CFLAGS=$pkg_cv_[]$1[]_CFLAGS
++	$1[]_LIBS=$pkg_cv_[]$1[]_LIBS
++        AC_MSG_RESULT([yes])
++	ifelse([$3], , :, [$3])
++fi[]dnl
++])# PKG_CHECK_MODULES
++
+ # Copyright (C) 2002, 2003, 2005  Free Software Foundation, Inc.
+ #
+ # This file is free software; the Free Software Foundation
+@@ -468,6 +624,27 @@ AC_DEFUN([AM_PROG_INSTALL_SH],
+ install_sh=${install_sh-"$am_aux_dir/install-sh"}
+ AC_SUBST(install_sh)])
+ 
++# Copyright (C) 2003, 2005  Free Software Foundation, Inc.
++#
++# This file is free software; the Free Software Foundation
++# gives unlimited permission to copy and/or distribute it,
++# with or without modifications, as long as this notice is preserved.
++
++# serial 2
++
++# Check whether the underlying file-system supports filenames
++# with a leading dot.  For instance MS-DOS doesn't.
++AC_DEFUN([AM_SET_LEADING_DOT],
++[rm -rf .tst 2>/dev/null
++mkdir .tst 2>/dev/null
++if test -d .tst; then
++  am__leading_dot=.
++else
++  am__leading_dot=_
++fi
++rmdir .tst 2>/dev/null
++AC_SUBST([am__leading_dot])])
++
+ # Add --enable-maintainer-mode option to configure.         -*- Autoconf -*-
+ # From Jim Meyering
+ 
+@@ -868,7 +1045,4 @@ m4_include([gnulib/m4/onceonly_2_57.m4])
+ m4_include([gnulib/m4/stdint.m4])
+ m4_include([gnulib/m4/string_h.m4])
+ m4_include([gnulib/m4/wchar.m4])
+-m4_include([../config/extensions.m4])
+-m4_include([../config/lead-dot.m4])
+-m4_include([../config/proginstall.m4])
+ m4_include([acinclude.m4])
+Index: gdb-6.8.50.20090302/gdb/config.in
+===================================================================
+--- gdb-6.8.50.20090302.orig/gdb/config.in	2009-03-07 17:13:33.000000000 +0100
++++ gdb-6.8.50.20090302/gdb/config.in	2009-03-07 17:25:06.000000000 +0100
+@@ -38,6 +38,9 @@
+ /* Define to BFD's default target vector. */
+ #undef DEFAULT_BFD_VEC
+ 
++/* librpm version specific library name to dlopen. */
++#undef DLOPEN_LIBRPM
++
+ /* Define to 1 if translation of program messages to the user's native
+    language is requested. */
+ #undef ENABLE_NLS
+@@ -211,6 +214,9 @@
+ /* Define if Python 2.6 is being used. */
+ #undef HAVE_LIBPYTHON2_6
+ 
++/* Define if librpm library is being used. */
++#undef HAVE_LIBRPM
++
+ /* Define if libunwind library is being used. */
+ #undef HAVE_LIBUNWIND
+ 
+Index: gdb-6.8.50.20090302/gdb/configure
+===================================================================
+--- gdb-6.8.50.20090302.orig/gdb/configure	2009-03-07 17:13:33.000000000 +0100
++++ gdb-6.8.50.20090302/gdb/configure	2009-03-07 17:25:06.000000000 +0100
+@@ -314,7 +314,7 @@ ac_subdirs_all="$ac_subdirs_all doc test
+ ac_subdirs_all="$ac_subdirs_all gdbtk"
+ ac_subdirs_all="$ac_subdirs_all multi-ice"
+ ac_subdirs_all="$ac_subdirs_all gdbserver"
+-ac_subst_vars='SHELL PATH_SEPARATOR PACKAGE_NAME PACKAGE_TARNAME PACKAGE_VERSION PACKAGE_STRING PACKAGE_BUGREPORT exec_prefix prefix program_transform_name bindir sbindir libexecdir datadir sysconfdir sharedstatedir localstatedir libdir includedir oldincludedir infodir mandir build_alias host_alias target_alias DEFS ECHO_C ECHO_N ECHO_T LIBS MAINTAINER_MODE_TRUE MAINTAINER_MODE_FALSE MAINT CC CFLAGS LDFLAGS CPPFLAGS ac_ct_CC EXEEXT OBJEXT CPP EGREP RANLIB ac_ct_RANLIB build build_cpu build_vendor build_os host host_cpu host_vendor host_os target target_cpu target_vendor target_os am__leading_dot DEPDIR CCDEPMODE MAKE GMAKE_TRUE GMAKE_FALSE SET_MAKE USE_NLS LIBINTL LIBINTL_DEP INCINTL XGETTEXT GMSGFMT POSUB CATALOGS DATADIRNAME INSTOBJEXT GENCAT CATOBJEXT localedir GL_COND_LIBTOOL_TRUE GL_COND_LIBTOOL_FALSE GNULIB_MEMMEM GNULIB_MEMPCPY GNULIB_MEMRCHR GNULIB_STPCPY GNULIB_STPNCPY GNULIB_STRCHRNUL GNULIB_STRDUP GNULIB_STRNDUP GNULIB_STRNLEN GNULIB_STRPBRK GNULIB_STRSEP GNULIB_
 STRSTR GNULIB_STRCASESTR GNULIB_STRTOK_R GNULIB_MBSLEN GNULIB_MBSNLEN GNULIB_MBSCHR GNULIB_MBSRCHR GNULIB_MBSSTR GNULIB_MBSCASECMP GNULIB_MBSNCASECMP GNULIB_MBSPCASECMP GNULIB_MBSCASESTR GNULIB_MBSCSPN GNULIB_MBSPBRK GNULIB_MBSSPN GNULIB_MBSSEP GNULIB_MBSTOK_R GNULIB_STRERROR GNULIB_STRSIGNAL HAVE_DECL_MEMMEM HAVE_MEMPCPY HAVE_DECL_MEMRCHR HAVE_STPCPY HAVE_STPNCPY HAVE_STRCHRNUL HAVE_DECL_STRDUP HAVE_STRNDUP HAVE_DECL_STRNDUP HAVE_DECL_STRNLEN HAVE_STRPBRK HAVE_STRSEP HAVE_STRCASESTR HAVE_DECL_STRTOK_R HAVE_DECL_STRERROR HAVE_DECL_STRSIGNAL REPLACE_STRERROR REPLACE_STRSIGNAL REPLACE_MEMMEM REPLACE_STRCASESTR REPLACE_STRSTR HAVE_LONG_LONG_INT HAVE_UNSIGNED_LONG_LONG_INT HAVE_INTTYPES_H HAVE_SYS_TYPES_H INCLUDE_NEXT NEXT_STDINT_H HAVE_STDINT_H HAVE_SYS_INTTYPES_H HAVE_SYS_BITYPES_H BITSIZEOF_PTRDIFF_T BITSIZEOF_SIG_ATOMIC_T BITSIZEOF_SIZE_T BITSIZEOF_WCHAR_T BITSIZEOF_WINT_T HAVE_SIGNED_SIG_ATOMIC_T HAVE_SIGNED_WCHAR_T HAVE_SIGNED_WINT_T PTRDIFF_T_SUFFIX SIG_ATOMIC_T_SUFFIX SI
 ZE_T_SUFFIX WCHAR_T_SUFFIX WINT_T_SUFFIX STDINT_H NEXT_STRING_H GNULIB_WCWIDTH HAVE_DECL_WCWIDTH REPLACE_WCWIDTH WCHAR_H HAVE_WCHAR_H NEXT_WCHAR_H LIBGNU_LIBDEPS LIBGNU_LTLIBDEPS GNULIB_STDINT_H PACKAGE INSTALL_PROGRAM INSTALL_SCRIPT INSTALL_DATA CYGPATH_W VERSION ACLOCAL AUTOCONF AUTOMAKE AUTOHEADER MAKEINFO install_sh STRIP ac_ct_STRIP INSTALL_STRIP_PROGRAM mkdir_p AWK AMTAR am__tar am__untar am__include am__quote AMDEP_TRUE AMDEP_FALSE AMDEPBACKSLASH am__fastdepCC_TRUE am__fastdepCC_FALSE GDB_DATADIR_PATH pythondir subdirs TARGET_OBS PKGVERSION REPORT_BUGS_TO REPORT_BUGS_TEXI LN_S YACC AR ac_ct_AR DLLTOOL ac_ct_DLLTOOL WINDRES ac_ct_WINDRES MIG ac_ct_MIG LIBICONV LIBICONV_INCLUDE LIBICONV_LIBDIR READLINE READLINE_DEPS READLINE_CFLAGS HAVE_LIBEXPAT LIBEXPAT LTLIBEXPAT PYTHON_CFLAGS ALLOCA CONFIG_LDFLAGS TARGET_SYSTEM_ROOT TARGET_SYSTEM_ROOT_DEFINE WARN_CFLAGS WERROR_CFLAGS SER_HARDWIRE WIN32LIBS LIBGUI GUI_CFLAGS_X WIN32LDAPP TCL_VERSION TCL_PATCH_LEVEL TCL_BIN_DIR TCL_SRC
 _DIR TCL_LIB_FILE TCL_LIB_FLAG TCL_LIB_SPEC TCL_STUB_LIB_FILE TCL_STUB_LIB_FLAG TCL_STUB_LIB_SPEC TCL_INCLUDE TCL_LIBRARY TCL_DEPS TK_VERSION TK_BIN_DIR TK_SRC_DIR TK_LIB_FILE TK_LIB_FLAG TK_LIB_SPEC TK_STUB_LIB_FILE TK_STUB_LIB_FLAG TK_STUB_LIB_SPEC TK_INCLUDE TK_LIBRARY TK_DEPS TK_XINCLUDES X_CFLAGS X_LDFLAGS X_LIBS GDBTKLIBS GDBTK_CFLAGS GDBTK_SRC_DIR SIM SIM_OBS ENABLE_CFLAGS PROFILE_CFLAGS CONFIG_OBS CONFIG_DEPS CONFIG_SRCS CONFIG_ALL CONFIG_CLEAN CONFIG_INSTALL CONFIG_UNINSTALL target_subdir frags nm_h LIBOBJS LTLIBOBJS gl_LIBOBJS gl_LTLIBOBJS gltests_LIBOBJS gltests_LTLIBOBJS'
++ac_subst_vars='SHELL PATH_SEPARATOR PACKAGE_NAME PACKAGE_TARNAME PACKAGE_VERSION PACKAGE_STRING PACKAGE_BUGREPORT exec_prefix prefix program_transform_name bindir sbindir libexecdir datadir sysconfdir sharedstatedir localstatedir libdir includedir oldincludedir infodir mandir build_alias host_alias target_alias DEFS ECHO_C ECHO_N ECHO_T LIBS MAINTAINER_MODE_TRUE MAINTAINER_MODE_FALSE MAINT CC CFLAGS LDFLAGS CPPFLAGS ac_ct_CC EXEEXT OBJEXT CPP EGREP RANLIB ac_ct_RANLIB build build_cpu build_vendor build_os host host_cpu host_vendor host_os target target_cpu target_vendor target_os am__leading_dot DEPDIR CCDEPMODE MAKE GMAKE_TRUE GMAKE_FALSE SET_MAKE USE_NLS LIBINTL LIBINTL_DEP INCINTL XGETTEXT GMSGFMT POSUB CATALOGS DATADIRNAME INSTOBJEXT GENCAT CATOBJEXT localedir GL_COND_LIBTOOL_TRUE GL_COND_LIBTOOL_FALSE GNULIB_MEMMEM GNULIB_MEMPCPY GNULIB_MEMRCHR GNULIB_STPCPY GNULIB_STPNCPY GNULIB_STRCHRNUL GNULIB_STRDUP GNULIB_STRNDUP GNULIB_STRNLEN GNULIB_STRPBRK GNULIB_STRSEP GNULIB_
 STRSTR GNULIB_STRCASESTR GNULIB_STRTOK_R GNULIB_MBSLEN GNULIB_MBSNLEN GNULIB_MBSCHR GNULIB_MBSRCHR GNULIB_MBSSTR GNULIB_MBSCASECMP GNULIB_MBSNCASECMP GNULIB_MBSPCASECMP GNULIB_MBSCASESTR GNULIB_MBSCSPN GNULIB_MBSPBRK GNULIB_MBSSPN GNULIB_MBSSEP GNULIB_MBSTOK_R GNULIB_STRERROR GNULIB_STRSIGNAL HAVE_DECL_MEMMEM HAVE_MEMPCPY HAVE_DECL_MEMRCHR HAVE_STPCPY HAVE_STPNCPY HAVE_STRCHRNUL HAVE_DECL_STRDUP HAVE_STRNDUP HAVE_DECL_STRNDUP HAVE_DECL_STRNLEN HAVE_STRPBRK HAVE_STRSEP HAVE_STRCASESTR HAVE_DECL_STRTOK_R HAVE_DECL_STRERROR HAVE_DECL_STRSIGNAL REPLACE_STRERROR REPLACE_STRSIGNAL REPLACE_MEMMEM REPLACE_STRCASESTR REPLACE_STRSTR HAVE_LONG_LONG_INT HAVE_UNSIGNED_LONG_LONG_INT HAVE_INTTYPES_H HAVE_SYS_TYPES_H INCLUDE_NEXT NEXT_STDINT_H HAVE_STDINT_H HAVE_SYS_INTTYPES_H HAVE_SYS_BITYPES_H BITSIZEOF_PTRDIFF_T BITSIZEOF_SIG_ATOMIC_T BITSIZEOF_SIZE_T BITSIZEOF_WCHAR_T BITSIZEOF_WINT_T HAVE_SIGNED_SIG_ATOMIC_T HAVE_SIGNED_WCHAR_T HAVE_SIGNED_WINT_T PTRDIFF_T_SUFFIX SIG_ATOMIC_T_SUFFIX SI
 ZE_T_SUFFIX WCHAR_T_SUFFIX WINT_T_SUFFIX STDINT_H NEXT_STRING_H GNULIB_WCWIDTH HAVE_DECL_WCWIDTH REPLACE_WCWIDTH WCHAR_H HAVE_WCHAR_H NEXT_WCHAR_H LIBGNU_LIBDEPS LIBGNU_LTLIBDEPS GNULIB_STDINT_H PACKAGE INSTALL_PROGRAM INSTALL_SCRIPT INSTALL_DATA CYGPATH_W VERSION ACLOCAL AUTOCONF AUTOMAKE AUTOHEADER MAKEINFO install_sh STRIP ac_ct_STRIP INSTALL_STRIP_PROGRAM mkdir_p AWK AMTAR am__tar am__untar am__include am__quote AMDEP_TRUE AMDEP_FALSE AMDEPBACKSLASH am__fastdepCC_TRUE am__fastdepCC_FALSE GDB_DATADIR_PATH pythondir PKG_CONFIG ac_pt_PKG_CONFIG RPM_CFLAGS RPM_LIBS subdirs TARGET_OBS PKGVERSION REPORT_BUGS_TO REPORT_BUGS_TEXI LN_S YACC AR ac_ct_AR DLLTOOL ac_ct_DLLTOOL WINDRES ac_ct_WINDRES MIG ac_ct_MIG LIBICONV LIBICONV_INCLUDE LIBICONV_LIBDIR READLINE READLINE_DEPS READLINE_CFLAGS HAVE_LIBEXPAT LIBEXPAT LTLIBEXPAT PYTHON_CFLAGS ALLOCA CONFIG_LDFLAGS TARGET_SYSTEM_ROOT TARGET_SYSTEM_ROOT_DEFINE WARN_CFLAGS WERROR_CFLAGS SER_HARDWIRE WIN32LIBS LIBGUI GUI_CFLAGS_X WIN32LDAPP
  TCL_VERSION TCL_PATCH_LEVEL TCL_BIN_DIR TCL_SRC_DIR TCL_LIB_FILE TCL_LIB_FLAG TCL_LIB_SPEC TCL_STUB_LIB_FILE TCL_STUB_LIB_FLAG TCL_STUB_LIB_SPEC TCL_INCLUDE TCL_LIBRARY TCL_DEPS TK_VERSION TK_BIN_DIR TK_SRC_DIR TK_LIB_FILE TK_LIB_FLAG TK_LIB_SPEC TK_STUB_LIB_FILE TK_STUB_LIB_FLAG TK_STUB_LIB_SPEC TK_INCLUDE TK_LIBRARY TK_DEPS TK_XINCLUDES X_CFLAGS X_LDFLAGS X_LIBS GDBTKLIBS GDBTK_CFLAGS GDBTK_SRC_DIR SIM SIM_OBS ENABLE_CFLAGS PROFILE_CFLAGS CONFIG_OBS CONFIG_DEPS CONFIG_SRCS CONFIG_ALL CONFIG_CLEAN CONFIG_INSTALL CONFIG_UNINSTALL target_subdir frags nm_h LIBOBJS LTLIBOBJS gl_LIBOBJS gl_LTLIBOBJS gltests_LIBOBJS gltests_LTLIBOBJS'
+ ac_subst_files='host_makefile_frag'
+ ac_pwd=`pwd`
+ 
+@@ -776,6 +776,18 @@ ac_env_CPP_set=${CPP+set}
+ ac_env_CPP_value=$CPP
+ ac_cv_env_CPP_set=${CPP+set}
+ ac_cv_env_CPP_value=$CPP
++ac_env_PKG_CONFIG_set=${PKG_CONFIG+set}
++ac_env_PKG_CONFIG_value=$PKG_CONFIG
++ac_cv_env_PKG_CONFIG_set=${PKG_CONFIG+set}
++ac_cv_env_PKG_CONFIG_value=$PKG_CONFIG
++ac_env_RPM_CFLAGS_set=${RPM_CFLAGS+set}
++ac_env_RPM_CFLAGS_value=$RPM_CFLAGS
++ac_cv_env_RPM_CFLAGS_set=${RPM_CFLAGS+set}
++ac_cv_env_RPM_CFLAGS_value=$RPM_CFLAGS
++ac_env_RPM_LIBS_set=${RPM_LIBS+set}
++ac_env_RPM_LIBS_value=$RPM_LIBS
++ac_cv_env_RPM_LIBS_set=${RPM_LIBS+set}
++ac_cv_env_RPM_LIBS_value=$RPM_LIBS
+ 
+ #
+ # Report the --help message.
+@@ -886,6 +898,8 @@ Optional Packages:
+                           [DATADIR/gdb]
+   --with-pythondir        install Python data files in this path
+                           [DATADIR/gdb/python]
++  --with-rpm              query rpm database for missing debuginfos
++                          [yes/no,], [def.], [auto=librpm.so]
+   --with-libunwind            Use libunwind frame unwinding support
+   --with-pkgversion=PKG   Use PKG in the version string in place of "GDB"
+   --with-bugurl=URL       Direct users to URL to report a bug
+@@ -913,6 +927,9 @@ Some influential environment variables:
+   CPPFLAGS    C/C++ preprocessor flags, e.g. -I<include dir> if you have
+               headers in a nonstandard directory <include dir>
+   CPP         C preprocessor
++  PKG_CONFIG  path to pkg-config utility
++  RPM_CFLAGS  C compiler flags for RPM, overriding pkg-config
++  RPM_LIBS    linker flags for RPM, overriding pkg-config
+ 
+ Use these variables to override the choices made by `configure' or to help
+ it to find libraries and programs with nonstandard names/locations.
+@@ -6556,7 +6573,6 @@ am__api_version="1.9"
+ # SVR4 /usr/ucb/install, which tries to use the nonexistent group "staff"
+ # OS/2's system install, which has a completely different semantic
+ # ./install, which can be erroneously created by make from ./install.sh.
+-# Reject install programs that cannot install multiple files.
+ echo "$as_me:$LINENO: checking for a BSD-compatible install" >&5
+ echo $ECHO_N "checking for a BSD-compatible install... $ECHO_C" >&6
+ if test -z "$INSTALL"; then
+@@ -6590,18 +6606,8 @@ case $as_dir/ in
+ 	    # program-specific install script used by HP pwplus--don't use.
+ 	    :
+ 	  else
+-	    rm -rf conftest.one conftest.two conftest.dir
+-	    echo one > conftest.one
+-	    echo two > conftest.two
+-	    mkdir conftest.dir
+-	    if "$as_dir/$ac_prog$ac_exec_ext" -c conftest.one conftest.two "`pwd`/conftest.dir" &&
+-	      test -s conftest.one && test -s conftest.two &&
+-	      test -s conftest.dir/conftest.one &&
+-	      test -s conftest.dir/conftest.two
+-	    then
+-	      ac_cv_path_install="$as_dir/$ac_prog$ac_exec_ext -c"
+-	      break 3
+-	    fi
++	    ac_cv_path_install="$as_dir/$ac_prog$ac_exec_ext -c"
++	    break 3
+ 	  fi
+ 	fi
+       done
+@@ -6610,16 +6616,15 @@ case $as_dir/ in
+ esac
+ done
+ 
+-rm -rf conftest.one conftest.two conftest.dir
+ 
+ fi
+   if test "${ac_cv_path_install+set}" = set; then
+     INSTALL=$ac_cv_path_install
+   else
+-    # As a last resort, use the slow shell script.  Don't cache a
+-    # value for INSTALL within a source directory, because that will
++    # As a last resort, use the slow shell script.  We don't cache a
++    # path for INSTALL within a source directory, because that will
+     # break other packages using the cache if that directory is
+-    # removed, or if the value is a relative name.
++    # removed, or if the path is relative.
+     INSTALL=$ac_install_sh
+   fi
+ fi
+@@ -7202,6 +7207,559 @@ _ACEOF
+ fi
+ 
+ 
++# Integration with rpm library to support missing debuginfo suggestions.
++# --without-rpm: Disable any rpm support.
++# --with-rpm=libname.so: Try to dynamically open `libname.so' during runtime.
++#   Even with runtime missing `libname.so' GDB will still other run correctly.
++#   Missing `libname.so' during ./configure will abort the configuration.
++# --with-rpm=librpm.so: Like `--with-rpm=libname.so' but try to find specific
++#   minor version first such as `librpm-4.6.so' as minor version differences
++#   mean API+ABI incompatibility.  If the specific match versioned library name
++#   could not be found still open dynamically at least `librpm.so'.
++# --with-rpm: Like `--with-rpm=librpm.so' but if any of its detection fails try
++#   to find librpm for compilation-time linking by pkg-config.  GDB binary will
++#   be probably linked with the version specific library (as `librpm-4.6.so').
++#   Failure to find librpm by pkg-config will abort the configuration.
++# (default) --with-rpm=auto: Like `--with-rpm=librpm.so' but if even pkg-config
++#   cannot find librpm use to the rpmless compilation (like `--without-rpm').
++
++
++# Check whether --with-rpm or --without-rpm was given.
++if test "${with_rpm+set}" = set; then
++  withval="$with_rpm"
++
++else
++  with_rpm="auto"
++fi;
++
++
++
++if test "x$with_rpm" != "xno"; then
++  if test "x$with_rpm" = "xyes"; then
++    LIBRPM="librpm.so"
++    RPM_REQUIRE=true
++    DLOPEN_REQUIRE=false
++  elif test "x$with_rpm" = "xauto"; then
++    LIBRPM="librpm.so"
++    RPM_REQUIRE=false
++    DLOPEN_REQUIRE=false
++  else
++    LIBRPM="$with_rpm"
++    RPM_REQUIRE=true
++    DLOPEN_REQUIRE=true
++  fi
++  LIBRPM_STRING='"'"$LIBRPM"'"'
++
++  echo "$as_me:$LINENO: checking specific librpm version" >&5
++echo $ECHO_N "checking specific librpm version... $ECHO_C" >&6
++  HAVE_DLOPEN_LIBRPM=false
++  save_LIBS="$LIBS"
++  LIBS="$LIBS -ldl"
++  if test "$cross_compiling" = yes; then
++  { { echo "$as_me:$LINENO: error: in \`$ac_pwd':" >&5
++echo "$as_me: error: in \`$ac_pwd':" >&2;}
++{ { echo "$as_me:$LINENO: error: cannot run test program while cross compiling
++See \`config.log' for more details." >&5
++echo "$as_me: error: cannot run test program while cross compiling
++See \`config.log' for more details." >&2;}
++   { (exit 1); exit 1; }; }; }
++else
++  cat >conftest.$ac_ext <<_ACEOF
++/* confdefs.h.  */
++_ACEOF
++cat confdefs.h >>conftest.$ac_ext
++cat >>conftest.$ac_ext <<_ACEOF
++/* end confdefs.h.  */
++
++#include <rpm/rpmlib.h>
++#include <dlfcn.h>
++#include <errno.h>
++
++int
++main ()
++{
++
++    void *h;
++    const char *const *rpmverp;
++    FILE *f;
++
++    f = fopen ("conftest.out", "w");
++    if (!f)
++      {
++	fprintf (stderr, "Cannot write \"%s\": %s\n", "conftest.out",
++		 strerror (errno));
++	return 1;
++      }
++    h = dlopen ($LIBRPM_STRING, RTLD_LAZY);
++    if (!h)
++      {
++	fprintf (stderr, "dlopen (\"%s\"): %s\n", $LIBRPM_STRING, dlerror ());
++	return 1;
++      }
++    rpmverp = dlsym (h, "RPMVERSION");
++    if (!rpmverp)
++      {
++	fprintf (stderr, "dlsym (\"RPMVERSION\"): %s\n", dlerror ());
++	return 1;
++      }
++    fprintf (stderr, "RPMVERSION is: \"");
++    fprintf (stderr, "%s\"\n", *rpmverp);
++
++    /* Try to find the specific librpm version only for "librpm.so" as we do
++       not know how to assemble the version string otherwise.  */
++
++    if (strcmp ("librpm.so", $LIBRPM_STRING) != 0)
++      {
++	fprintf (f, "%s\n", $LIBRPM_STRING);
++	return 0;
++      }
++    else
++      {
++	char *h2_name;
++	void *h2;
++	int major, minor;
++
++	if (sscanf (*rpmverp, "%d.%d", &major, &minor) != 2)
++	  {
++	    fprintf (stderr, "Unable to parse RPMVERSION.\n");
++	    fprintf (f, "%s\n", $LIBRPM_STRING);
++	    return 0;
++	  }
++	/* Avoid the square brackets by malloc.  */
++	h2_name = malloc (64);
++	sprintf (h2_name, "librpm-%d.%d.so", major, minor);
++	h2 = dlopen (h2_name, RTLD_LAZY);
++	if (!h2)
++	  {
++	    fprintf (stderr, "dlopen (\"%s\"): %s\n", h2_name, dlerror ());
++	    fprintf (f, "%s\n", $LIBRPM_STRING);
++	    return 0;
++	  }
++	if (h2 != h)
++	  {
++	    fprintf (stderr, "dlopen of \"%s\" and \"%s\" are different.\n",
++		     $LIBRPM_STRING, h2_name);
++	    fprintf (f, "%s\n", $LIBRPM_STRING);
++	    return 0;
++	  }
++	/* Found the valid .so name with a specific version.  */
++	fprintf (f, "%s\n", h2_name);
++	return 0;
++      }
++
++  ;
++  return 0;
++}
++_ACEOF
++rm -f conftest$ac_exeext
++if { (eval echo "$as_me:$LINENO: \"$ac_link\"") >&5
++  (eval $ac_link) 2>&5
++  ac_status=$?
++  echo "$as_me:$LINENO: \$? = $ac_status" >&5
++  (exit $ac_status); } && { ac_try='./conftest$ac_exeext'
++  { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
++  (eval $ac_try) 2>&5
++  ac_status=$?
++  echo "$as_me:$LINENO: \$? = $ac_status" >&5
++  (exit $ac_status); }; }; then
++
++    DLOPEN_LIBRPM="`cat conftest.out`"
++    if test "x$DLOPEN_LIBRPM" != "x"; then
++      HAVE_DLOPEN_LIBRPM=true
++      echo "$as_me:$LINENO: result: $DLOPEN_LIBRPM" >&5
++echo "${ECHO_T}$DLOPEN_LIBRPM" >&6
++    fi
++
++else
++  echo "$as_me: program exited with status $ac_status" >&5
++echo "$as_me: failed program was:" >&5
++sed 's/^/| /' conftest.$ac_ext >&5
++
++fi
++rm -f core *.core gmon.out bb.out conftest$ac_exeext conftest.$ac_objext conftest.$ac_ext
++fi
++  rm -f conftest.out
++
++
++
++  if $HAVE_DLOPEN_LIBRPM; then
++
++    echo "$as_me:$LINENO: checking rpm library API compatibility" >&5
++echo $ECHO_N "checking rpm library API compatibility... $ECHO_C" >&6
++    # The compilation requires -Werror to verify anything.
++    save_CFLAGS="$CFLAGS"
++    CFLAGS="$CFLAGS -Werror"
++    cat >conftest.$ac_ext <<_ACEOF
++/* confdefs.h.  */
++_ACEOF
++cat confdefs.h >>conftest.$ac_ext
++cat >>conftest.$ac_ext <<_ACEOF
++/* end confdefs.h.  */
++
++/* Duplicate here the declarations to verify they match "symfile.c".  */
++#include <rpm/rpmlib.h>
++#include <rpm/rpmts.h>
++#include <rpm/rpmdb.h>
++#include <rpm/header.h>
++extern char * headerFormat(Header h, const char * fmt, errmsg_t * errmsg);
++extern int rpmReadConfigFiles(const char * file, const char * target);
++extern rpmdbMatchIterator rpmdbFreeIterator(rpmdbMatchIterator mi);
++extern Header rpmdbNextIterator(rpmdbMatchIterator mi);
++extern rpmts rpmtsCreate(void);
++extern rpmts rpmtsFree(rpmts ts);
++extern rpmdbMatchIterator rpmtsInitIterator(const rpmts ts, rpmTag rpmtag,
++					    const void * keyp, size_t keylen);
++
++int
++main ()
++{
++
++  ;
++  return 0;
++}
++_ACEOF
++rm -f conftest.$ac_objext
++if { (eval echo "$as_me:$LINENO: \"$ac_compile\"") >&5
++  (eval $ac_compile) 2>conftest.er1
++  ac_status=$?
++  grep -v '^ *+' conftest.er1 >conftest.err
++  rm -f conftest.er1
++  cat conftest.err >&5
++  echo "$as_me:$LINENO: \$? = $ac_status" >&5
++  (exit $ac_status); } &&
++	 { ac_try='test -z "$ac_c_werror_flag"
++			 || test ! -s conftest.err'
++  { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
++  (eval $ac_try) 2>&5
++  ac_status=$?
++  echo "$as_me:$LINENO: \$? = $ac_status" >&5
++  (exit $ac_status); }; } &&
++	 { ac_try='test -s conftest.$ac_objext'
++  { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
++  (eval $ac_try) 2>&5
++  ac_status=$?
++  echo "$as_me:$LINENO: \$? = $ac_status" >&5
++  (exit $ac_status); }; }; then
++
++      LIBRPM_COMPAT=true
++      echo "$as_me:$LINENO: result: yes" >&5
++echo "${ECHO_T}yes" >&6
++
++else
++  echo "$as_me: failed program was:" >&5
++sed 's/^/| /' conftest.$ac_ext >&5
++
++
++      LIBRPM_COMPAT=false
++      echo "$as_me:$LINENO: result: no" >&5
++echo "${ECHO_T}no" >&6
++
++fi
++rm -f conftest.err conftest.$ac_objext conftest.$ac_ext
++    CFLAGS="$save_CFLAGS"
++
++    if ! $LIBRPM_COMPAT; then
++      HAVE_DLOPEN_LIBRPM=false
++    fi
++  fi
++
++  if $HAVE_DLOPEN_LIBRPM; then
++    DLOPEN_LIBRPM_STRING='"'"$DLOPEN_LIBRPM"'"'
++
++cat >>confdefs.h <<_ACEOF
++#define DLOPEN_LIBRPM $DLOPEN_LIBRPM_STRING
++_ACEOF
++
++
++cat >>confdefs.h <<\_ACEOF
++#define HAVE_LIBRPM 1
++_ACEOF
++
++  else
++    echo "$as_me:$LINENO: result: no" >&5
++echo "${ECHO_T}no" >&6
++    LIBS="$save_LIBS"
++    if $DLOPEN_REQUIRE; then
++      { { echo "$as_me:$LINENO: error: Specific name $LIBRPM was requested but it could not be opened." >&5
++echo "$as_me: error: Specific name $LIBRPM was requested but it could not be opened." >&2;}
++   { (exit 1); exit 1; }; }
++    fi
++
++
++if test "x$ac_cv_env_PKG_CONFIG_set" != "xset"; then
++	if test -n "$ac_tool_prefix"; then
++  # Extract the first word of "${ac_tool_prefix}pkg-config", so it can be a program name with args.
++set dummy ${ac_tool_prefix}pkg-config; ac_word=$2
++echo "$as_me:$LINENO: checking for $ac_word" >&5
++echo $ECHO_N "checking for $ac_word... $ECHO_C" >&6
++if test "${ac_cv_path_PKG_CONFIG+set}" = set; then
++  echo $ECHO_N "(cached) $ECHO_C" >&6
++else
++  case $PKG_CONFIG in
++  [\\/]* | ?:[\\/]*)
++  ac_cv_path_PKG_CONFIG="$PKG_CONFIG" # Let the user override the test with a path.
++  ;;
++  *)
++  as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
++for as_dir in $PATH
++do
++  IFS=$as_save_IFS
++  test -z "$as_dir" && as_dir=.
++  for ac_exec_ext in '' $ac_executable_extensions; do
++  if $as_executable_p "$as_dir/$ac_word$ac_exec_ext"; then
++    ac_cv_path_PKG_CONFIG="$as_dir/$ac_word$ac_exec_ext"
++    echo "$as_me:$LINENO: found $as_dir/$ac_word$ac_exec_ext" >&5
++    break 2
++  fi
++done
++done
++
++  ;;
++esac
++fi
++PKG_CONFIG=$ac_cv_path_PKG_CONFIG
++
++if test -n "$PKG_CONFIG"; then
++  echo "$as_me:$LINENO: result: $PKG_CONFIG" >&5
++echo "${ECHO_T}$PKG_CONFIG" >&6
++else
++  echo "$as_me:$LINENO: result: no" >&5
++echo "${ECHO_T}no" >&6
++fi
++
++fi
++if test -z "$ac_cv_path_PKG_CONFIG"; then
++  ac_pt_PKG_CONFIG=$PKG_CONFIG
++  # Extract the first word of "pkg-config", so it can be a program name with args.
++set dummy pkg-config; ac_word=$2
++echo "$as_me:$LINENO: checking for $ac_word" >&5
++echo $ECHO_N "checking for $ac_word... $ECHO_C" >&6
++if test "${ac_cv_path_ac_pt_PKG_CONFIG+set}" = set; then
++  echo $ECHO_N "(cached) $ECHO_C" >&6
++else
++  case $ac_pt_PKG_CONFIG in
++  [\\/]* | ?:[\\/]*)
++  ac_cv_path_ac_pt_PKG_CONFIG="$ac_pt_PKG_CONFIG" # Let the user override the test with a path.
++  ;;
++  *)
++  as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
++for as_dir in $PATH
++do
++  IFS=$as_save_IFS
++  test -z "$as_dir" && as_dir=.
++  for ac_exec_ext in '' $ac_executable_extensions; do
++  if $as_executable_p "$as_dir/$ac_word$ac_exec_ext"; then
++    ac_cv_path_ac_pt_PKG_CONFIG="$as_dir/$ac_word$ac_exec_ext"
++    echo "$as_me:$LINENO: found $as_dir/$ac_word$ac_exec_ext" >&5
++    break 2
++  fi
++done
++done
++
++  ;;
++esac
++fi
++ac_pt_PKG_CONFIG=$ac_cv_path_ac_pt_PKG_CONFIG
++
++if test -n "$ac_pt_PKG_CONFIG"; then
++  echo "$as_me:$LINENO: result: $ac_pt_PKG_CONFIG" >&5
++echo "${ECHO_T}$ac_pt_PKG_CONFIG" >&6
++else
++  echo "$as_me:$LINENO: result: no" >&5
++echo "${ECHO_T}no" >&6
++fi
++
++  PKG_CONFIG=$ac_pt_PKG_CONFIG
++else
++  PKG_CONFIG="$ac_cv_path_PKG_CONFIG"
++fi
++
++fi
++if test -n "$PKG_CONFIG"; then
++	_pkg_min_version=0.9.0
++	echo "$as_me:$LINENO: checking pkg-config is at least version $_pkg_min_version" >&5
++echo $ECHO_N "checking pkg-config is at least version $_pkg_min_version... $ECHO_C" >&6
++	if $PKG_CONFIG --atleast-pkgconfig-version $_pkg_min_version; then
++		echo "$as_me:$LINENO: result: yes" >&5
++echo "${ECHO_T}yes" >&6
++	else
++		echo "$as_me:$LINENO: result: no" >&5
++echo "${ECHO_T}no" >&6
++		PKG_CONFIG=""
++	fi
++
++fi
++
++pkg_failed=no
++echo "$as_me:$LINENO: checking for RPM" >&5
++echo $ECHO_N "checking for RPM... $ECHO_C" >&6
++
++if test -n "$RPM_CFLAGS"; then
++    pkg_cv_RPM_CFLAGS="$RPM_CFLAGS"
++ elif test -n "$PKG_CONFIG"; then
++    if test -n "$PKG_CONFIG" && \
++    { (echo "$as_me:$LINENO: \$PKG_CONFIG --exists --print-errors \"rpm\"") >&5
++  ($PKG_CONFIG --exists --print-errors "rpm") 2>&5
++  ac_status=$?
++  echo "$as_me:$LINENO: \$? = $ac_status" >&5
++  (exit $ac_status); }; then
++  pkg_cv_RPM_CFLAGS=`$PKG_CONFIG --cflags "rpm" 2>/dev/null`
++else
++  pkg_failed=yes
++fi
++ else
++    pkg_failed=untried
++fi
++if test -n "$RPM_LIBS"; then
++    pkg_cv_RPM_LIBS="$RPM_LIBS"
++ elif test -n "$PKG_CONFIG"; then
++    if test -n "$PKG_CONFIG" && \
++    { (echo "$as_me:$LINENO: \$PKG_CONFIG --exists --print-errors \"rpm\"") >&5
++  ($PKG_CONFIG --exists --print-errors "rpm") 2>&5
++  ac_status=$?
++  echo "$as_me:$LINENO: \$? = $ac_status" >&5
++  (exit $ac_status); }; then
++  pkg_cv_RPM_LIBS=`$PKG_CONFIG --libs "rpm" 2>/dev/null`
++else
++  pkg_failed=yes
++fi
++ else
++    pkg_failed=untried
++fi
++
++
++
++if test $pkg_failed = yes; then
++
++if $PKG_CONFIG --atleast-pkgconfig-version 0.20; then
++        _pkg_short_errors_supported=yes
++else
++        _pkg_short_errors_supported=no
++fi
++        if test $_pkg_short_errors_supported = yes; then
++	        RPM_PKG_ERRORS=`$PKG_CONFIG --short-errors --print-errors "rpm" 2>&1`
++        else
++	        RPM_PKG_ERRORS=`$PKG_CONFIG --print-errors "rpm" 2>&1`
++        fi
++	# Put the nasty error message in config.log where it belongs
++	echo "$RPM_PKG_ERRORS" >&5
++
++	echo "$as_me:$LINENO: result: no" >&5
++echo "${ECHO_T}no" >&6
++                HAVE_LIBRPM=false
++elif test $pkg_failed = untried; then
++	HAVE_LIBRPM=false
++else
++	RPM_CFLAGS=$pkg_cv_RPM_CFLAGS
++	RPM_LIBS=$pkg_cv_RPM_LIBS
++        echo "$as_me:$LINENO: result: yes" >&5
++echo "${ECHO_T}yes" >&6
++	HAVE_LIBRPM=true
++fi
++
++    if $HAVE_LIBRPM; then
++
++    echo "$as_me:$LINENO: checking rpm library API compatibility" >&5
++echo $ECHO_N "checking rpm library API compatibility... $ECHO_C" >&6
++    # The compilation requires -Werror to verify anything.
++    save_CFLAGS="$CFLAGS"
++    CFLAGS="$CFLAGS -Werror"
++    cat >conftest.$ac_ext <<_ACEOF
++/* confdefs.h.  */
++_ACEOF
++cat confdefs.h >>conftest.$ac_ext
++cat >>conftest.$ac_ext <<_ACEOF
++/* end confdefs.h.  */
++
++/* Duplicate here the declarations to verify they match "symfile.c".  */
++#include <rpm/rpmlib.h>
++#include <rpm/rpmts.h>
++#include <rpm/rpmdb.h>
++#include <rpm/header.h>
++extern char * headerFormat(Header h, const char * fmt, errmsg_t * errmsg);
++extern int rpmReadConfigFiles(const char * file, const char * target);
++extern rpmdbMatchIterator rpmdbFreeIterator(rpmdbMatchIterator mi);
++extern Header rpmdbNextIterator(rpmdbMatchIterator mi);
++extern rpmts rpmtsCreate(void);
++extern rpmts rpmtsFree(rpmts ts);
++extern rpmdbMatchIterator rpmtsInitIterator(const rpmts ts, rpmTag rpmtag,
++					    const void * keyp, size_t keylen);
++
++int
++main ()
++{
++
++  ;
++  return 0;
++}
++_ACEOF
++rm -f conftest.$ac_objext
++if { (eval echo "$as_me:$LINENO: \"$ac_compile\"") >&5
++  (eval $ac_compile) 2>conftest.er1
++  ac_status=$?
++  grep -v '^ *+' conftest.er1 >conftest.err
++  rm -f conftest.er1
++  cat conftest.err >&5
++  echo "$as_me:$LINENO: \$? = $ac_status" >&5
++  (exit $ac_status); } &&
++	 { ac_try='test -z "$ac_c_werror_flag"
++			 || test ! -s conftest.err'
++  { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
++  (eval $ac_try) 2>&5
++  ac_status=$?
++  echo "$as_me:$LINENO: \$? = $ac_status" >&5
++  (exit $ac_status); }; } &&
++	 { ac_try='test -s conftest.$ac_objext'
++  { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
++  (eval $ac_try) 2>&5
++  ac_status=$?
++  echo "$as_me:$LINENO: \$? = $ac_status" >&5
++  (exit $ac_status); }; }; then
++
++      LIBRPM_COMPAT=true
++      echo "$as_me:$LINENO: result: yes" >&5
++echo "${ECHO_T}yes" >&6
++
++else
++  echo "$as_me: failed program was:" >&5
++sed 's/^/| /' conftest.$ac_ext >&5
++
++
++      LIBRPM_COMPAT=false
++      echo "$as_me:$LINENO: result: no" >&5
++echo "${ECHO_T}no" >&6
++
++fi
++rm -f conftest.err conftest.$ac_objext conftest.$ac_ext
++    CFLAGS="$save_CFLAGS"
++
++      if ! $LIBRPM_COMPAT; then
++	HAVE_LIBRPM=false
++	RPM_PKG_ERRORS="Found $LIBRPM API is incompatibile with this GDB"
++      fi
++    fi
++
++    if $HAVE_LIBRPM; then
++
++cat >>confdefs.h <<\_ACEOF
++#define HAVE_LIBRPM 1
++_ACEOF
++
++      CFLAGS="$CFLAGS $RPM_CFLAGS"
++      LIBS="$LIBS $RPM_LIBS"
++    else
++      if $RPM_REQUIRE; then
++	{ { echo "$as_me:$LINENO: error: $RPM_PKG_ERRORS" >&5
++echo "$as_me: error: $RPM_PKG_ERRORS" >&2;}
++   { (exit 1); exit 1; }; }
++      else
++	{ echo "$as_me:$LINENO: WARNING: $RPM_PKG_ERRORS" >&5
++echo "$as_me: WARNING: $RPM_PKG_ERRORS" >&2;}
++      fi
++    fi
++  fi
++fi
++
+ 
+ 
+ 
+@@ -8623,7 +9181,6 @@ done
+ # SVR4 /usr/ucb/install, which tries to use the nonexistent group "staff"
+ # OS/2's system install, which has a completely different semantic
+ # ./install, which can be erroneously created by make from ./install.sh.
+-# Reject install programs that cannot install multiple files.
+ echo "$as_me:$LINENO: checking for a BSD-compatible install" >&5
+ echo $ECHO_N "checking for a BSD-compatible install... $ECHO_C" >&6
+ if test -z "$INSTALL"; then
+@@ -8657,18 +9214,8 @@ case $as_dir/ in
+ 	    # program-specific install script used by HP pwplus--don't use.
+ 	    :
+ 	  else
+-	    rm -rf conftest.one conftest.two conftest.dir
+-	    echo one > conftest.one
+-	    echo two > conftest.two
+-	    mkdir conftest.dir
+-	    if "$as_dir/$ac_prog$ac_exec_ext" -c conftest.one conftest.two "`pwd`/conftest.dir" &&
+-	      test -s conftest.one && test -s conftest.two &&
+-	      test -s conftest.dir/conftest.one &&
+-	      test -s conftest.dir/conftest.two
+-	    then
+-	      ac_cv_path_install="$as_dir/$ac_prog$ac_exec_ext -c"
+-	      break 3
+-	    fi
++	    ac_cv_path_install="$as_dir/$ac_prog$ac_exec_ext -c"
++	    break 3
+ 	  fi
+ 	fi
+       done
+@@ -8677,16 +9224,15 @@ case $as_dir/ in
+ esac
+ done
+ 
+-rm -rf conftest.one conftest.two conftest.dir
+ 
+ fi
+   if test "${ac_cv_path_install+set}" = set; then
+     INSTALL=$ac_cv_path_install
+   else
+-    # As a last resort, use the slow shell script.  Don't cache a
+-    # value for INSTALL within a source directory, because that will
++    # As a last resort, use the slow shell script.  We don't cache a
++    # path for INSTALL within a source directory, because that will
+     # break other packages using the cache if that directory is
+-    # removed, or if the value is a relative name.
++    # removed, or if the path is relative.
+     INSTALL=$ac_install_sh
+   fi
+ fi
+@@ -22270,6 +22816,10 @@ s, at am__fastdepCC_TRUE@,$am__fastdepCC_TR
+ s, at am__fastdepCC_FALSE@,$am__fastdepCC_FALSE,;t t
+ s, at GDB_DATADIR_PATH@,$GDB_DATADIR_PATH,;t t
+ s, at pythondir@,$pythondir,;t t
++s, at PKG_CONFIG@,$PKG_CONFIG,;t t
++s, at ac_pt_PKG_CONFIG@,$ac_pt_PKG_CONFIG,;t t
++s, at RPM_CFLAGS@,$RPM_CFLAGS,;t t
++s, at RPM_LIBS@,$RPM_LIBS,;t t
+ s, at subdirs@,$subdirs,;t t
+ s, at TARGET_OBS@,$TARGET_OBS,;t t
+ s, at PKGVERSION@,$PKGVERSION,;t t
+Index: gdb-6.8.50.20090302/gdb/configure.ac
+===================================================================
+--- gdb-6.8.50.20090302.orig/gdb/configure.ac	2009-03-07 17:13:33.000000000 +0100
++++ gdb-6.8.50.20090302/gdb/configure.ac	2009-03-07 17:25:06.000000000 +0100
+@@ -162,6 +162,199 @@ else
+ fi
+ AC_SUBST(pythondir)
+ 
++# Integration with rpm library to support missing debuginfo suggestions.
++# --without-rpm: Disable any rpm support.
++# --with-rpm=libname.so: Try to dynamically open `libname.so' during runtime.
++#   Even with runtime missing `libname.so' GDB will still other run correctly.
++#   Missing `libname.so' during ./configure will abort the configuration.
++# --with-rpm=librpm.so: Like `--with-rpm=libname.so' but try to find specific
++#   minor version first such as `librpm-4.6.so' as minor version differences
++#   mean API+ABI incompatibility.  If the specific match versioned library name
++#   could not be found still open dynamically at least `librpm.so'.
++# --with-rpm: Like `--with-rpm=librpm.so' but if any of its detection fails try
++#   to find librpm for compilation-time linking by pkg-config.  GDB binary will
++#   be probably linked with the version specific library (as `librpm-4.6.so').
++#   Failure to find librpm by pkg-config will abort the configuration.
++# (default) --with-rpm=auto: Like `--with-rpm=librpm.so' but if even pkg-config
++#   cannot find librpm use to the rpmless compilation (like `--without-rpm').
++
++AC_ARG_WITH([rpm],
++  [AS_HELP_STRING([--with-rpm],
++                  [query rpm database for missing debuginfos [yes/no, def. auto=librpm.so]])], [], [with_rpm="auto"])
++
++m4_pattern_allow([^AC_MSG_ERROR$])
++m4_pattern_allow([^AC_MSG_WARN$])
++if test "x$with_rpm" != "xno"; then
++  if test "x$with_rpm" = "xyes"; then
++    LIBRPM="librpm.so"
++    RPM_REQUIRE=true
++    DLOPEN_REQUIRE=false
++  elif test "x$with_rpm" = "xauto"; then
++    LIBRPM="librpm.so"
++    RPM_REQUIRE=false
++    DLOPEN_REQUIRE=false
++  else
++    LIBRPM="$with_rpm"
++    RPM_REQUIRE=true
++    DLOPEN_REQUIRE=true
++  fi
++  LIBRPM_STRING='"'"$LIBRPM"'"'
++
++  AC_MSG_CHECKING([specific librpm version])
++  HAVE_DLOPEN_LIBRPM=false
++  save_LIBS="$LIBS"
++  LIBS="$LIBS -ldl"
++  AC_RUN_IFELSE(AC_LANG_PROGRAM([[
++#include <rpm/rpmlib.h>
++#include <dlfcn.h>
++#include <errno.h>
++  ]], [[
++    void *h;
++    const char *const *rpmverp;
++    FILE *f;
++
++    f = fopen ("conftest.out", "w");
++    if (!f)
++      {
++	fprintf (stderr, "Cannot write \"%s\": %s\n", "conftest.out",
++		 strerror (errno));
++	return 1;
++      }
++    h = dlopen ($LIBRPM_STRING, RTLD_LAZY);
++    if (!h)
++      {
++	fprintf (stderr, "dlopen (\"%s\"): %s\n", $LIBRPM_STRING, dlerror ());
++	return 1;
++      }
++    rpmverp = dlsym (h, "RPMVERSION");
++    if (!rpmverp)
++      {
++	fprintf (stderr, "dlsym (\"RPMVERSION\"): %s\n", dlerror ());
++	return 1;
++      }
++    fprintf (stderr, "RPMVERSION is: \"");
++    fprintf (stderr, "%s\"\n", *rpmverp);
++
++    /* Try to find the specific librpm version only for "librpm.so" as we do
++       not know how to assemble the version string otherwise.  */
++
++    if (strcmp ("librpm.so", $LIBRPM_STRING) != 0)
++      {
++	fprintf (f, "%s\n", $LIBRPM_STRING);
++	return 0;
++      }
++    else
++      {
++	char *h2_name;
++	void *h2;
++	int major, minor;
++
++	if (sscanf (*rpmverp, "%d.%d", &major, &minor) != 2)
++	  {
++	    fprintf (stderr, "Unable to parse RPMVERSION.\n");
++	    fprintf (f, "%s\n", $LIBRPM_STRING);
++	    return 0;
++	  }
++	/* Avoid the square brackets by malloc.  */
++	h2_name = malloc (64);
++	sprintf (h2_name, "librpm-%d.%d.so", major, minor);
++	h2 = dlopen (h2_name, RTLD_LAZY);
++	if (!h2)
++	  {
++	    fprintf (stderr, "dlopen (\"%s\"): %s\n", h2_name, dlerror ());
++	    fprintf (f, "%s\n", $LIBRPM_STRING);
++	    return 0;
++	  }
++	if (h2 != h)
++	  {
++	    fprintf (stderr, "dlopen of \"%s\" and \"%s\" are different.\n",
++		     $LIBRPM_STRING, h2_name);
++	    fprintf (f, "%s\n", $LIBRPM_STRING);
++	    return 0;
++	  }
++	/* Found the valid .so name with a specific version.  */
++	fprintf (f, "%s\n", h2_name);
++	return 0;
++      }
++  ]]), [
++    DLOPEN_LIBRPM="`cat conftest.out`"
++    if test "x$DLOPEN_LIBRPM" != "x"; then
++      HAVE_DLOPEN_LIBRPM=true
++      AC_MSG_RESULT($DLOPEN_LIBRPM)
++    fi
++  ])
++  rm -f conftest.out
++
++  m4_define([CHECK_LIBRPM_COMPAT], [
++    AC_MSG_CHECKING([rpm library API compatibility])
++    # The compilation requires -Werror to verify anything.
++    save_CFLAGS="$CFLAGS"
++    CFLAGS="$CFLAGS -Werror"
++    AC_COMPILE_IFELSE(AC_LANG_PROGRAM([[
++/* Duplicate here the declarations to verify they match "symfile.c".  */
++#include <rpm/rpmlib.h>
++#include <rpm/rpmts.h>
++#include <rpm/rpmdb.h>
++#include <rpm/header.h>
++extern char * headerFormat(Header h, const char * fmt, errmsg_t * errmsg);
++extern int rpmReadConfigFiles(const char * file, const char * target);
++extern rpmdbMatchIterator rpmdbFreeIterator(rpmdbMatchIterator mi);
++extern Header rpmdbNextIterator(rpmdbMatchIterator mi);
++extern rpmts rpmtsCreate(void);
++extern rpmts rpmtsFree(rpmts ts);
++extern rpmdbMatchIterator rpmtsInitIterator(const rpmts ts, rpmTag rpmtag,
++					    const void * keyp, size_t keylen);
++    ]]), [
++      LIBRPM_COMPAT=true
++      AC_MSG_RESULT(yes)
++    ], [
++      LIBRPM_COMPAT=false
++      AC_MSG_RESULT(no)
++    ])
++    CFLAGS="$save_CFLAGS"
++  ])
++
++  if $HAVE_DLOPEN_LIBRPM; then
++    CHECK_LIBRPM_COMPAT
++    if ! $LIBRPM_COMPAT; then
++      HAVE_DLOPEN_LIBRPM=false
++    fi
++  fi
++
++  if $HAVE_DLOPEN_LIBRPM; then
++    DLOPEN_LIBRPM_STRING='"'"$DLOPEN_LIBRPM"'"'
++    AC_DEFINE_UNQUOTED(DLOPEN_LIBRPM, $DLOPEN_LIBRPM_STRING, [librpm version specific library name to dlopen.])
++    AC_DEFINE(HAVE_LIBRPM, 1, [Define if librpm library is being used.])
++  else
++    AC_MSG_RESULT(no)
++    LIBS="$save_LIBS"
++    if $DLOPEN_REQUIRE; then
++      AC_MSG_ERROR([Specific name $LIBRPM was requested but it could not be opened.])
++    fi
++    PKG_CHECK_MODULES(RPM, rpm, [HAVE_LIBRPM=true], [HAVE_LIBRPM=false])
++
++    if $HAVE_LIBRPM; then
++      CHECK_LIBRPM_COMPAT
++      if ! $LIBRPM_COMPAT; then
++	HAVE_LIBRPM=false
++	RPM_PKG_ERRORS="Found $LIBRPM API is incompatibile with this GDB"
++      fi
++    fi
++
++    if $HAVE_LIBRPM; then
++      AC_DEFINE(HAVE_LIBRPM, 1, [Define if librpm library is being used.])
++      CFLAGS="$CFLAGS $RPM_CFLAGS"
++      LIBS="$LIBS $RPM_LIBS"
++    else
++      if $RPM_REQUIRE; then
++	AC_MSG_ERROR($RPM_PKG_ERRORS)
++      else
++	AC_MSG_WARN($RPM_PKG_ERRORS)
++      fi
++    fi
++  fi
++fi
++
+ 
+ AC_CONFIG_SUBDIRS(doc testsuite)
+ 

gdb-6.6-buildid-locate.patch:

Index: gdb-6.6-buildid-locate.patch
===================================================================
RCS file: /cvs/pkgs/rpms/gdb/devel/gdb-6.6-buildid-locate.patch,v
retrieving revision 1.18
retrieving revision 1.19
diff -u -r1.18 -r1.19
--- gdb-6.6-buildid-locate.patch	7 Mar 2009 01:42:03 -0000	1.18
+++ gdb-6.6-buildid-locate.patch	7 Mar 2009 16:52:39 -0000	1.19
@@ -1,5 +1,7 @@
---- ./gdb/corelow.c	2009-03-07 01:45:51.000000000 +0100
-+++ ./gdb/corelow.c	2009-03-07 02:29:31.000000000 +0100
+Index: gdb-6.8.50.20090302/gdb/corelow.c
+===================================================================
+--- gdb-6.8.50.20090302.orig/gdb/corelow.c	2009-02-23 01:03:48.000000000 +0100
++++ gdb-6.8.50.20090302/gdb/corelow.c	2009-03-07 17:04:57.000000000 +0100
 @@ -45,6 +45,10 @@
  #include "exceptions.h"
  #include "solib.h"
@@ -93,8 +95,10 @@
 +			   NULL, NULL, NULL,
 +			   &setlist, &showlist);
  }
---- ./gdb/doc/gdb.texinfo	2009-03-07 01:45:51.000000000 +0100
-+++ ./gdb/doc/gdb.texinfo	2009-03-07 02:10:11.000000000 +0100
+Index: gdb-6.8.50.20090302/gdb/doc/gdb.texinfo
+===================================================================
+--- gdb-6.8.50.20090302.orig/gdb/doc/gdb.texinfo	2009-03-07 17:04:56.000000000 +0100
++++ gdb-6.8.50.20090302/gdb/doc/gdb.texinfo	2009-03-07 17:04:57.000000000 +0100
 @@ -13294,6 +13294,27 @@ information files.
  
  @end table
@@ -123,8 +127,10 @@
  @cindex @code{.gnu_debuglink} sections
  @cindex debug link sections
  A debug link is a special section of the executable file named
---- ./gdb/solib-svr4.c	2009-03-07 01:45:51.000000000 +0100
-+++ ./gdb/solib-svr4.c	2009-03-07 02:10:11.000000000 +0100
+Index: gdb-6.8.50.20090302/gdb/solib-svr4.c
+===================================================================
+--- gdb-6.8.50.20090302.orig/gdb/solib-svr4.c	2009-03-07 17:04:52.000000000 +0100
++++ gdb-6.8.50.20090302/gdb/solib-svr4.c	2009-03-07 17:04:57.000000000 +0100
 @@ -1000,9 +1000,33 @@ svr4_current_sos (void)
  		     safe_strerror (errcode));
  	  else
@@ -162,8 +168,10 @@
  	    }
  	  xfree (buffer);
  
---- ./gdb/symfile.c	2009-03-07 01:45:51.000000000 +0100
-+++ ./gdb/symfile.c	2009-03-07 02:30:20.000000000 +0100
+Index: gdb-6.8.50.20090302/gdb/symfile.c
+===================================================================
+--- gdb-6.8.50.20090302.orig/gdb/symfile.c	2009-03-07 17:04:53.000000000 +0100
++++ gdb-6.8.50.20090302/gdb/symfile.c	2009-03-07 17:22:21.000000000 +0100
 @@ -54,6 +54,7 @@
  #include "elf-bfd.h"
  #include "solib.h"
@@ -651,7 +659,7 @@
 +}
 +
 +/* This MISSING_FILEPAIR_HASH tracker is used only for the duplicite messages
-+     yum --enablerepo='*-debuginfo' install ...
++     Try to install the hash file ...
 +   avoidance.  */
 +
 +struct missing_filepair
@@ -774,8 +782,8 @@
 +  fprintf_unfiltered (gdb_stdlog,
 +		      _("Missing separate debuginfo for %s\n"), binary);
 +  if (debug != NULL)
-+    fprintf_unfiltered (gdb_stdlog, _("Try: %s %s\n"),
-+			"yum --enablerepo='*-debuginfo' install", debug);
++    fprintf_unfiltered (gdb_stdlog, _("Try to install the hash file %s\n"),
++			debug);
 +}
 +
  static char *
@@ -938,8 +946,10 @@
 +
 +  observer_attach_executable_changed (debug_print_executable_changed);
  }
---- ./gdb/symfile.h	2009-03-07 01:45:51.000000000 +0100
-+++ ./gdb/symfile.h	2009-03-07 02:16:18.000000000 +0100
+Index: gdb-6.8.50.20090302/gdb/symfile.h
+===================================================================
+--- gdb-6.8.50.20090302.orig/gdb/symfile.h	2009-03-07 17:04:52.000000000 +0100
++++ gdb-6.8.50.20090302/gdb/symfile.h	2009-03-07 17:13:33.000000000 +0100
 @@ -372,6 +372,13 @@ extern int symfile_map_offsets_to_segmen
  struct symfile_segment_data *get_symfile_segment_data (bfd *abfd);
  void free_symfile_segment_data (struct symfile_segment_data *data);
@@ -954,8 +964,10 @@
  /* From dwarf2read.c */
  
  extern int dwarf2_has_info (struct objfile *);
---- ./gdb/testsuite/lib/gdb.exp	2009-03-07 01:45:51.000000000 +0100
-+++ ./gdb/testsuite/lib/gdb.exp	2009-03-07 02:10:11.000000000 +0100
+Index: gdb-6.8.50.20090302/gdb/testsuite/lib/gdb.exp
+===================================================================
+--- gdb-6.8.50.20090302.orig/gdb/testsuite/lib/gdb.exp	2009-03-07 17:04:52.000000000 +0100
++++ gdb-6.8.50.20090302/gdb/testsuite/lib/gdb.exp	2009-03-07 17:13:33.000000000 +0100
 @@ -1230,6 +1230,16 @@ proc default_gdb_start { } {
  	    warning "Couldn't set the width to 0."
  	}


Index: gdb.spec
===================================================================
RCS file: /cvs/pkgs/rpms/gdb/devel/gdb.spec,v
retrieving revision 1.328
retrieving revision 1.329
diff -u -r1.328 -r1.329
--- gdb.spec	7 Mar 2009 01:42:03 -0000	1.328
+++ gdb.spec	7 Mar 2009 16:52:39 -0000	1.329
@@ -13,7 +13,7 @@
 
 # The release always contains a leading reserved number, start it at 1.
 # `upstream' is not a part of `name' to stay fully rpm dependencies compatible for the testing.
-Release: 4%{?_with_upstream:.upstream}%{?dist}
+Release: 5%{?_with_upstream:.upstream}%{?dist}
 
 License: GPLv3+
 Group: Development/Debuggers
@@ -378,7 +378,8 @@
 BuildRequires: ncurses-devel texinfo gettext flex bison expat-devel
 Requires: readline
 BuildRequires: readline-devel
-Requires: rpm-libs
+# dlopen() no longer makes rpm-libs a mandatory dependency.
+#Requires: rpm-libs
 BuildRequires: rpm-devel
 %{!?python_sitelib: %global python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")}
 Requires: python-libs
@@ -635,6 +636,7 @@
 	--with-expat					\
 	--enable-tui					\
 	--with-python					\
+	--with-rpm=librpm.so				\
 %ifarch ia64
 	--with-libunwind				\
 %else
@@ -838,6 +840,9 @@
 %endif
 
 %changelog
+* Sat Mar  7 2009 Jan Kratochvil <jan.kratochvil at redhat.com> - 6.8.50.20090302-5
+- Improve `gdb-6.6-buildid-locate-rpm.patch' by dlopen() (+pkg-config compat.).
+
 * Sat Mar  7 2009 Jan Kratochvil <jan.kratochvil at redhat.com> - 6.8.50.20090302-4
 - Split `gdb-6.6-buildid-locate.patch' to `gdb-6.6-buildid-locate-rpm.patch'.
 




More information about the fedora-extras-commits mailing list